<bugID>1341591<Summary>Create an automated way of generating the list of top sites we ship with Firefox</Summary><Description>There's a small python script in bug 858829 that we could build on. Alexa now also has a paid-for API that we could consider using.

There's a number of considerations here. Here's a (potentially incomplete) list:

1) how many items do we want to ship?
2) for which items can we use https by default
3) for which items should we use "www.&lt;whatever&gt;" rather than "&lt;whatever&gt;" ? Ideally we should avoid server-side redirects with the default autocomplete entries, which will then clutter up future autocomplete results.
4) we should remove adult content (potentially using the hardcoded list mobile uses, but it's not clear to me how often those domains are likely to change and how it's generated).
5) should we include titles?
6) should the list be localized in some way so e.g. French users get lemonde.fr but English users don't?
7) when / how often should the list be updated?


My proposal would be to use 100 items and include titles, to fix 2-4, and punt on 6/7.

I'd use 100 items because I think after 100 we get into the long tail and doing this becomes a lot less interesting. The remaining 900 (or 999,900...) add to processing time, disk space, memory usage, and clutter up results, but are probably only 1-10% of actual visits for users, so I don't think there's much of a point. Users will visit those pages on their own.

So ship 100 items to everyone, use the mobile list to remove adult content, and use marionette to at least detect redirects and whether shipping with http or https, and with or without 'www.', makes more sense (so load the http URL without 'www.', then determine if the final URL has https and/or www, and use that information in the final URL we use).

I would punt on localizing or automatically updating the list for now to reduce complexity - this should be reasonably straightforward to do in the future if we want to, once we have an automated way of compiling it.

In the future, we could extend the script to also store favicon information to help with shipping those (not just for the location bar suggestions, but maybe also for places / new tab when we have imported history).

For the titles, I think we should just use the document title once the load completes, strip anything after the first punctuation ('-', '.', ':', etc.) that we encounter (so you end up with "Facebook", and not "Facebook - Log In or Sign Up") and trim off any remaining whitespace.

Marco and Sveta, does that sound like a sane plan to you? (Sveta, don't worry if it's not immediately clear how you would implement some of these things or what marionette is, I can help with that. :-) )</Description></bugID>